Subject: Re: Debugging Git push failure

From: Neal Kreitzinger <[email-masked]>
Date: Thu, 10 Feb 2011 13:06:09 -0600

On 2/9/2011 12:57 PM, Jeff Adamson wrote:
> Several developers on my team are experiencing an occasional failure
> during push.  A subsequent push executed immediately afterward the
> failure will work fine.  We are a small team of developers (about 10)
> and only a couple users seem to experience this and then only
> intermittently (every few days).
> This is happening on a LAN environment with otherwise reliable
> connectivity.  We have some hook scripts for post-update and update
> configured within the repo.
>
> the server has git version 1.7.3.3 installed
> $ cat /etc/issue
> CentOS release 5.5 (Final)
> Kernel \r on an \m
> $ uname -a
> Linux core1.example.com 2.6.18-194.26.1.el5 #1 SMP Tue Nov 9 12:54:20
> EST 2010 x86_64 x86_64 x86_64 GNU/Linux
>
> Here is some output from one of the users during two sequential runs
> of `git push -v`.  This user is git version 1.7.3.1.msysgit.0 (though
> similar behavior has been seen by another user with version 1.7.0.4 on
> ubuntu 10.04 LTS)
>> git push -v
> Pushing to ssh://git.example.com/data/git/example/scratch/bdd/cssearch-mockup.git
> Counting objects: 9, done.
> Delta compression using up to 8 threads.
> Compressing objects: 100% (5/5), done.
> Writing objects: 100% (5/5), 505 bytes, done.
> Total 5 (delta 4), reused 0 (delta 0)
> fatal: The remote end hung up unexpectedly
> fatal: The remote end hung up unexpectedly
>> git push -v
> Pushing to ssh://git.example.com/data/git/example/scratch/bdd/cssearch-mockup.git
> Counting objects: 9, done.
> Delta compression using up to 8 threads.
> Compressing objects: 100% (5/5), done.
> Writing objects: 100% (5/5), 505 bytes, done.
> Total 5 (delta 4), reused 0 (delta 0)
> To ssh://git.example.com/data/git/example/scratch/bdd/cssearch-mockup.git
>    bffa1a7..8fd772d  master ->  master
>
>
> Anyone know what could be causing this and, just as important, how to
> debug it and issues like it in the future?
> Thanks for any help/insight which can be offered.
> --Jeff
I don't use ssh, but I use the git:// protocol and have also had push 
errors locally.  I run RHEL and when I get errors with git protocol I 
check /var/log/messages.  Find out where your log messages are going and 
check them.  You could also check permissions on the destination repo. 
Look at its object store recursively, ie. .git/objects/, and do "ls -la" 
to see the permissions.  People could be pushing stuff up with the wrong 
permissions and then someone else can't get to it.  Just some ideas...

v/r,
Neal